/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2014, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@member.fsf.org
----------------------------------------------------------------------------*/
#ifndef APBUART_PLUGIN_UI_H
#define APBUART_PLUGIN_UI_H

#include <QWidget>
#include <QCompleter>
#include <QStringListModel>

namespace Ui {
class APBUART_Plugin_ui;
}

class APBUART_Plugin_ui : public QWidget
{
    Q_OBJECT

public:
    explicit APBUART_Plugin_ui(QWidget *parent = 0);
    ~APBUART_Plugin_ui();
    int curentAPBUart();
public slots:
    void setEnableForLoopBack(bool enable);
    void setUartConnected(bool enable);
    void updatePortList();
    void updateAPBUartList(QList<unsigned int> addresses);
    void setUartSpeed(int speed);
    void setUartPortName(QString name);
    void setAPBUartIndex(int index);
private slots:

signals:
    void curentAPBUartChanged(int index);
    void loopbackChkBxStateChanged( int state );
    void apbUartTextReceived(QString text);
    void connectPort();
    void sendChar(char c);
    void UartSpeedChanged(QString text);
    void PortNameChanged(QString text);
    void updateAPBUartsList();
private:
    Ui::APBUART_Plugin_ui *ui;
    QCompleter *portListcompleter;
    QStringListModel *portListcompleterModel;
};

#endif // APBUART_PLUGIN_UI_H
