/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2013, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@member.fsf.org
----------------------------------------------------------------------------*/
#include "apbuartterminal.h"

ApbUartTerminal::ApbUartTerminal(QWidget *parent) :
    QTextEdit(parent)
{
//    connect(this,SIGNAL(apbUartTextReceived(QString)),this,SLOT(append(QString)));
    setReadOnly(true);
}

void ApbUartTerminal::keyPressEvent(QKeyEvent *e)
{
    if((e->modifiers()==(Qt::ShiftModifier | Qt::ControlModifier)) && (e->key()==Qt::Key_L))
        this->clear();
    else
        emit this->sendChar((char)e->key());
    e->accept();
}

void ApbUartTerminal::apbUartTextReceived(QString text)
{
    moveCursor (QTextCursor::End);
    insertPlainText (text);
    moveCursor (QTextCursor::End);
}
