/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2011, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------*/
#ifndef AHBUARTPLUGINUI_H
#define AHBUARTPLUGINUI_H

#include <QWidget>
#include <QFile>
#include <QTextStream>
#include <QFileDialog>
#include <QDir>
#include <QCloseEvent>
#include <QCompleter>

namespace Ui {
    class ahbUartPluginUI;
}

class ahbUartPluginUI : public QWidget
{
    Q_OBJECT

public:
    explicit ahbUartPluginUI(QWidget *parent = 0);
    ~ahbUartPluginUI();
    void closeEvent(QCloseEvent *event);
    void setCompleter(QCompleter* completer);
    int baudRate();
public slots:
    void setConnected(bool connected);
    void connectPort();
    void setconfig(QString PortName,int baudrate);
    void addWritenBytes(int count);
    void addReadBytes(int count);
    void setSystemSpeed(int speed);

signals:
    void connectPortsig(QString PortName,int baudrate);
    void setLogFileName(QString FileName);
    void rescanPorts();
private:
    int writtenBytes;
    int readBytes;
    Ui::ahbUartPluginUI *ui;
    QCompleter* portSpeedCompleter;
};

#endif // AHBUARTPLUGINUI_H





