/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2011, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------*/
#ifndef AHBPLUGINUI_H
#define AHBPLUGINUI_H

#include <QWidget>
#include <QHBoxLayout>
#include <QPushButton>
#include "ahbdevicelist.h"
#include <socexplorerplugin.h>
#define AHB_PLUGNPLAY_MASTER_START ((unsigned int)(0xFFFFF000))
#define AHB_PLUGNPLAY_MASTER_STOP  ((unsigned int)(0xFFFFF800))
#define AHB_PLUGNPLAY_SLAVE_START  ((unsigned int)(0xFFFFF800))
#define AHB_PLUGNPLAY_SLAVE_STOP   ((unsigned int)(0xFFFFFFFC))
/*0001 = APB I/O space
0010 = AHB Memory space
0011 = AHB I/O space
*/
#define AHB_PLUGNPLAY_APB_IO_SPACE 0x01
#define AHB_PLUGNPLAY_MEMORY_SPACE 0x02
#define AHB_PLUGNPLAY_AHB_IO_SPACE 0x03

class ahbPluginUi : public QWidget
{
    Q_OBJECT
public:
    explicit ahbPluginUi(socexplorerplugin* plugin,QWidget *parent = 0);
    ahbdeviceInfo* extractInfos(unsigned int* pnpregs);
public slots:
    void scanAHB();
signals:
    void addAHBdevice(ahbdeviceInfo* device);
    void clearAHBdevicesList();
    unsigned int WriteSig(unsigned int* Value,unsigned int count,unsigned int address);
    unsigned int ReadSig(unsigned int* Value,unsigned int count,unsigned int address);
private:
    QHBoxLayout* mainlayout;
    QPushButton* scanBp;
    ahbdevicelist* deviceslst;
    socexplorerplugin* _plugin;


};

#endif // AHBPLUGINUI_H
