/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2012, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------*/
#include "ambaplugin.h"


ambaplugin::ambaplugin(QWidget *parent):socexplorerplugin(parent,true)
{
    this->UI = new ambaPluginUI(this);
    this->setWidget((QWidget*)this->UI);
    connect(this->UI,SIGNAL(ReadSig(uint*,uint,uint)),this,SLOT(Read(uint*,uint,uint)));
    connect(this->UI,SIGNAL(WriteSig(uint*,uint,uint)),this,SLOT(Write(uint*,uint,uint)));
    connect(this,SIGNAL(activateSig(bool)),this,SLOT(activatePlugin(bool)));
}


ambaplugin::~ambaplugin()
{
    
}


void ambaplugin::closeMe()
{
    emit this->closePlugin(this);
}

void ambaplugin::postInstantiationTrigger()
{
    if(this->parent->isConnected())
    {
        this->UI->scanAll();
    }
}

void ambaplugin::activatePlugin(bool flag)
{
    if(flag)
    {
        this->UI->scanAll();
    }
}

int ambaplugin::registermenu(QMainWindow *menuHolder)
{
    this->menu = menuHolder->menuBar()->addMenu(tr("&ambaplugin"));
    this->closeAction = this->menu->addAction(tr("Close plugin"));
    QObject::connect(this->closeAction,SIGNAL(triggered()),this,SLOT(closeMe()));
    return 1;
}



unsigned int ambaplugin::Read(unsigned int *Value,unsigned int count,unsigned int address)
{
    if(parent!=NULL)
        return parent->Read(Value,count,address);
    return 0;
}

unsigned int ambaplugin::Write(unsigned int *Value,unsigned int count, unsigned int address)
{
    if(parent!=NULL)
        return parent->Write(Value,count,address);
    return 0;
}








