/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2012, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------*/
#ifndef ambaplugin_H
#define ambaplugin_H
#include <QMenuBar>
#include <QMenu>
#include <QAction>
#include <QLayout>
#include "ambapluginui.h"
#include <socexplorerplugin.h>



class ambaplugin : public socexplorerplugin
{
    Q_OBJECT
public:
    explicit ambaplugin(QWidget *parent = 0);
    ~ambaplugin();
    int registermenu(QMainWindow *menuHolder);
    int VID(){return driver_VID;}
    int PID(){return driver_PID;}
    
public slots:
    unsigned int Write(unsigned int *Value,unsigned int count, unsigned int address=0);
    unsigned int Read(unsigned int *Value,unsigned int count, unsigned int address=0);
    void closeMe();
    void postInstantiationTrigger();
    void activatePlugin(bool flag);
signals:
    
private:
     ambaPluginUI* UI;
};

#endif // ambaplugin_H

