/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2012, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------*/
#ifndef AMBAPLUGINUI_H
#define AMBAPLUGINUI_H

#include <QWidget>
#include <QVBoxLayout>
#include <QGridLayout>
#include <QPushButton>
#include "AHB/ahbpluginui.h"
#include "APB/apbpluginui.h"

class ambaPluginUI : public QWidget
{
    Q_OBJECT
public:
    explicit ambaPluginUI(socexplorerplugin* plugin,QWidget *parent = 0);
    
signals:
    unsigned int WriteSig(unsigned int* Value,unsigned int count,unsigned int address);
    unsigned int ReadSig(unsigned int* Value,unsigned int count,unsigned int address);
public slots:
    void scanAll();
private:
    QGridLayout* mainLayout;
    ahbPluginUi* ahbPlugin;
    apbPluginUi* apbPlugin;
};

#endif // AMBAPLUGINUI_H
