/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2013, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------*/

#include <dsu3pluginui.h>

dsu3pluginui::dsu3pluginui(QWidget *parent)
    :QWidget(parent)
{
    this->openFileQpb = new QPushButton(tr("Open File"));
    this->flashTargetQpb = new QPushButton(tr("Flash Target"));
    this->runQpb = new QPushButton(tr("Run"));
    this->mainLayout = new QGridLayout();
    this->elfFileWidgetInst = new elfFileWidget();
    this->mainLayout->addWidget(this->openFileQpb,0,0,1,1);
    this->mainLayout->addWidget(this->flashTargetQpb,0,1,1,1);
    this->mainLayout->addWidget(this->runQpb,0,2,1,1);
    this->mainLayout->addWidget(this->elfFileWidgetInst,1,0,1,-1);
    this->setLayout(this->mainLayout);
    connect(this->openFileQpb,SIGNAL(clicked()),this,SIGNAL(openFile()));
    connect(this->flashTargetQpb,SIGNAL(clicked()),this,SIGNAL(flashTarget()));
    connect(this->runQpb,SIGNAL(clicked()),this,SIGNAL(run()));

}

void dsu3pluginui::setRunning(bool running)
{
    if(running)
        this->runQpb->setText("Stop");
    else
        this->runQpb->setText("Run");
}

void dsu3pluginui::updateInfo(ElfFile *file)
{
    this->elfFileWidgetInst->setFile(file);
}











