/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2011, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------*/
#ifndef AHBPLUGINUI_H
#define AHBPLUGINUI_H

#include <QWidget>
#include <QHBoxLayout>
#include <QTabWidget>
#include <QPushButton>
#include "memeditor.h"
#include <QSplitter>


class genericrwpluginUi : public QWidget
{
    Q_OBJECT
public:
    explicit genericrwpluginUi(QWidget *parent = 0);

signals:
    unsigned int WriteSig(unsigned int* Value,unsigned int count,unsigned int address);
    unsigned int ReadSig(unsigned int* Value,unsigned int count,unsigned int address);
    void refresh();
    void setAddress(quint32 address);
    void setLength(quint32 length);

private:
    QSplitter* verticalSpliter;
    QHBoxLayout* mainlayout;
    QTabWidget* tabWdgt;
    memEditor* memEditorWdgt;

};

#endif // AHBPLUGINUI_H
