/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2014, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@lpp.polytechnique.fr
----------------------------------------------------------------------------*/
#include "memcheckplugin_ui.h"
#include "ui_memcheckplugin_ui.h"
#include <memsizewdgt.h>
#include <qhexspinbox.h>

memcheckplugin_ui::memcheckplugin_ui(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::memcheckplugin_ui)
{
    ui->setupUi(this);
    connect(this->ui->StartTestQpb,SIGNAL(clicked()),this,SLOT(startCheck()));
}

memcheckplugin_ui::~memcheckplugin_ui()
{
    delete ui;
}

void memcheckplugin_ui::startCheck()
{
    if(this->ui->testTypeQchkBx->currentText()=="Check data bits")
    {
        emit checkdatabits(this->ui->StartAddress->value(),this->ui->MemSize->getsize());
    }
    if(this->ui->testTypeQchkBx->currentText()=="Check memory size")
    {
        //emit checkmemory(this->ui->StartAddress->value(),this->ui->MemSize->getsize());
        emit checkmemorySize(this->ui->StartAddress->value(),this->ui->MemSize->getsize());
    }
    if(this->ui->testTypeQchkBx->currentText()=="Full test")
    {

    }
}

void memcheckplugin_ui::setResult(bool success, QString repport)
{
    this->ui->testDetails->setText(repport);
    if(success)
    {
        this->ui->TestResult->setText("Success");
    }
    else
    {
        this->ui->TestResult->setText("Failed");
    }
}
